summaryrefslogtreecommitdiffstats
path: root/src/ceph/admin/build-doc
diff options
context:
space:
mode:
authorQiaowei Ren <qiaowei.ren@intel.com>2018-01-04 13:43:33 +0800
committerQiaowei Ren <qiaowei.ren@intel.com>2018-01-05 11:59:39 +0800
commit812ff6ca9fcd3e629e49d4328905f33eee8ca3f5 (patch)
tree04ece7b4da00d9d2f98093774594f4057ae561d4 /src/ceph/admin/build-doc
parent15280273faafb77777eab341909a3f495cf248d9 (diff)
initial code repo
This patch creates initial code repo. For ceph, luminous stable release will be used for base code, and next changes and optimization for ceph will be added to it. For opensds, currently any changes can be upstreamed into original opensds repo (https://github.com/opensds/opensds), and so stor4nfv will directly clone opensds code to deploy stor4nfv environment. And the scripts for deployment based on ceph and opensds will be put into 'ci' directory. Change-Id: I46a32218884c75dda2936337604ff03c554648e4 Signed-off-by: Qiaowei Ren <qiaowei.ren@intel.com>
Diffstat (limited to 'src/ceph/admin/build-doc')
-rwxr-xr-xsrc/ceph/admin/build-doc133
1 files changed, 133 insertions, 0 deletions
diff --git a/src/ceph/admin/build-doc b/src/ceph/admin/build-doc
new file mode 100755
index 0000000..0caa048
--- /dev/null
+++ b/src/ceph/admin/build-doc
@@ -0,0 +1,133 @@
+#!/bin/sh
+
+cd "$(dirname "$0")"
+cd ..
+TOPDIR=`pwd`
+
+install -d -m0755 build-doc
+
+if command -v dpkg >/dev/null; then
+ packages=`cat ${TOPDIR}/doc_deps.deb.txt`
+ for package in $packages; do
+ if [ "$(dpkg --status -- $package 2>&1 | sed -n 's/^Status: //p')" != "install ok installed" ]; then
+ # add a space after old values
+ missing="${missing:+$missing }$package"
+ fi
+ done
+ if [ -n "$missing" ]; then
+ echo "$0: missing required packages, please install them:" 1>&2
+ echo "sudo apt-get install -o APT::Install-Recommends=true $missing" 1>&2
+ exit 1
+ fi
+elif command -v yum >/dev/null; then
+ for package in python-devel python-pip python-virtualenv doxygen ditaa ant libxml2-devel libxslt-devel Cython graphviz; do
+ if ! rpm -q $package >/dev/null ; then
+ missing="${missing:+$missing }$package"
+ fi
+ done
+ if [ -n "$missing" ]; then
+ echo "$0: missing required packages, please install them:" 1>&2
+ echo "yum install $missing"
+ exit 1
+ fi
+else
+ for command in virtualenv doxygen ant ditaa cython; do
+ command -v "$command" > /dev/null;
+ ret_code=$?
+ if [ $ret_code -ne 0 ]; then
+ # add a space after old values
+ missing="${missing:+$missing }$command"
+ fi
+ done
+ if [ -n "$missing" ]; then
+ echo "$0: missing required command, please install them:" 1>&2
+ echo "$missing"
+ exit 1
+ fi
+fi
+
+# Don't enable -e until after running all the potentially-erroring checks
+# for availability of commands
+set -e
+
+cat $TOPDIR/src/osd/PG.h $TOPDIR/src/osd/PG.cc | $TOPDIR/doc/scripts/gen_state_diagram.py > $TOPDIR/doc/dev/peering_graph.generated.dot
+
+cd build-doc
+
+[ -z "$vdir" ] && vdir="$TOPDIR/build-doc/virtualenv"
+
+if [ ! -e $vdir ]; then
+ virtualenv --system-site-packages $vdir -p python2
+fi
+$vdir/bin/pip install --quiet -r $TOPDIR/admin/doc-requirements.txt
+
+install -d -m0755 \
+ $TOPDIR/build-doc/output/html \
+ $TOPDIR/build-doc/output/man
+
+# To avoid having to build librbd to build the Python bindings to build the docs,
+# create a dummy librbd.so that allows the module to be imported by sphinx.
+# the module are imported by the "automodule::" directive.
+mkdir -p $vdir/lib
+export LD_LIBRARY_PATH="$vdir/lib"
+export PYTHONPATH=$TOPDIR/src/pybind
+
+# FIXME(sileht): I dunno how to pass the include-dirs correctly with pip
+# for build_ext step, it should be:
+# --global-option=build_ext --global-option="--cython-include-dirs $TOPDIR/src/pybind/rados/"
+# but that doesn't work, so copying the file in the rbd module directly, that's ok for docs
+for bind in rados rbd cephfs rgw; do
+ if [ ${bind} != rados ]; then
+ cp -f $TOPDIR/src/pybind/rados/rados.pxd $TOPDIR/src/pybind/${bind}/
+ fi
+ ln -sf lib${bind}.so.1 $vdir/lib/lib${bind}.so
+ gcc -shared -o $vdir/lib/lib${bind}.so.1 -xc /dev/null
+ BUILD_DOC=1 \
+ CFLAGS="-iquote$TOPDIR/src/include" \
+ CPPFLAGS="-iquote$TOPDIR/src/include" \
+ LDFLAGS="-L$vdir/lib -Wl,--no-as-needed" \
+ $vdir/bin/pip install $TOPDIR/src/pybind/${bind}
+ # rgwfile_version(), librgw_create(), rgw_mount()
+ nm $vdir/lib/python*/*-packages/${bind}.so | grep -E "U (lib)?${bind}" | \
+ awk '{ print "void "$2"(void) {}" }' | \
+ gcc -shared -o $vdir/lib/lib${bind}.so.1 -xc -
+ if [ ${bind} != rados ]; then
+ rm -f $TOPDIR/src/pybind/${bind}/rados.pxd
+ fi
+done
+
+if [ -z "$@" ]; then
+ sphinx_targets="html man"
+else
+ sphinx_targets=$@
+fi
+for target in $sphinx_targets; do
+ builder=$target
+ case $target in
+ html)
+ builder=dirhtml
+ ;;
+ man)
+ extra_opt="-t man"
+ ;;
+ esac
+ $vdir/bin/sphinx-build -a -b $builder $extra_opt -d doctrees \
+ $TOPDIR/doc $TOPDIR/build-doc/output/$target
+done
+
+#
+# Build and install JavaDocs
+#
+JAVADIR=$TOPDIR/src/java
+
+# Clean and build JavaDocs
+rm -rf $JAVADIR/doc
+ant -buildfile $JAVADIR/build.xml docs
+
+# Create clean target directory
+JAVA_OUTDIR=$TOPDIR/build-doc/output/html/api/libcephfs-java/javadoc
+rm -rf $JAVA_OUTDIR
+mkdir $JAVA_OUTDIR
+
+# Copy JavaDocs to target directory
+cp -a $JAVADIR/doc/* $JAVA_OUTDIR/